/*

Copyright (c) 2001-2004 Fritz Ganter <ganter@ganter.at>
Website: www.gpsdrive.de

Modifications for ipaq specific version
Copyright (c) 2007 Andrew M. Bishop <amb@gedanken.demon.co.uk>
Website: http://www.gedanken.demon.co.uk/gpsdrive-ipaq/

Disclaimer: Please do not use for navigation. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    **********************************************************************/

/*  Include Dateien */
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "gpsdrive.h"
#include "config.h"

#if HAVE_LOCALE_H
#include <locale.h>
#else
# define setlocale(Category, Locale)
#endif
#include "gettext.h"

#include <time.h>
#include <dirent.h>
#include <gmodule.h>
#include <gdk/gdktypes.h>
#include <gtk/gtk.h>


/*  Defines for gettext I18n */
# include <libintl.h>
# define _(String) gettext(String)
# ifdef gettext_noop
#  define N_(String) gettext_noop(String)
# else
#  define N_(String) (String)
# endif

gchar homedir[500], mapdir[500];

extern gint debug;
typedef struct
{
  gchar n[200];
}
namesstruct;
extern namesstruct *names;
extern GtkWidget *setupfn[30];
extern gchar activewpfile[200];
extern GtkWidget *serialbt, *mapdirbt;
extern gint minsecmode, nightmode, isnight;
extern gint needtosave;
extern gint disableserial;
extern gchar serialdev[80];
extern GtkWidget *miles, *setupbt;
extern gint milesflag;
extern gint metricflag, nauticflag;
extern GtkWidget *setupentry[50], *setupentrylabel[50];
extern gdouble current_long, current_lat;
static gdouble hour, sunrise, sunset, suntransit;
static gdouble duskastro, dawnastro, dusknaut, dawnnaut, duskciv, dawnciv;
extern gchar loctime[20];
static GtkWidget *utclabel;
static gint utctimer, triptimer = 0;
extern gdouble tripodometer, tripavspeed, triptime, tripmaxspeed, milesconv;
extern gint tripavspeedcount;
extern gint lastnotebook;
extern GtkWidget *settingsnotebook;
GtkWidget *ge12;
static gchar *slist[] =
  { "GMT-12", "GMT-11", "GMT-10", "GMT-9", "GMT-8", "GMT-7", "GMT-6", "GMT-5",
  "GMT-4", "GMT-3", "GMT-2", "GMT-1", "GMT+0", "GMT+1", "GMT+2", "GMT+3",
  "GMT+4", "GMT+5",
  "GMT+6", "GMT+7", "GMT+8", "GMT+9", "GMT+10", "GMT+11", "GMT+12"
};
gint zone;
extern int serialspeed, disableserial;

extern gint storetz;
GtkWidget *entryavspeed, *entrymaxspeed, *entrytripodometer, *entrytriptime,
  *tripunitlabel;
extern int sound_direction, sound_distance, sound_speed, sound_gps;

static void
baud_cb (GtkOptionMenu * button, gint data)
{
  serialspeed = gtk_option_menu_get_history (button);
}


gint
soundsettings_cb (GtkWidget * widget, guint datum)
{

  switch (datum)
    {
    case 1:
      sound_direction = !sound_direction;
      break;
    case 2:
      sound_distance = !sound_distance;
      break;
    case 3:
      sound_speed = !sound_speed;
      break;
    case 4:
      sound_gps = !sound_gps;
      break;
    }
  needtosave = TRUE;
  return TRUE;
}


void
mainsetup (void)
{
  GtkWidget *mainbox, *ftable, *label1, *gpstable;
  GtkWidget *metric, *nautic, *minsecbt;
  GtkWidget *table2, *nighttable, *label1a;
  GtkWidget *label2, *f2, *f4, *f5;
  GtkWidget *night1, *night2, *night3, *vbox, *noserialbt;
  GtkWidget *v2, *v4, *h2;
  GtkWidget *mainbox2;
  gchar path2[400];
  DIR *d;
  struct dirent *dat;
  gint dircount = 0, i;
  GtkWidget *menu, *menu_item;
  GtkWidget *option_menu;
  char buf2[20];
  int br = 2400;
  GtkWidget *sounddirbt, *sounddistbt, *soundspeedbt, *soundgpsbt,
    *soundtable, *framesound;

  g_strlcpy (path2, homedir, sizeof (path2));
  names = g_new (namesstruct, 102);

  d = opendir (path2);
  if (d != NULL)
    {
      do
	{
	  dat = readdir (d);
	  if (dat != NULL)
	    {
	      if ((strncmp (dat->d_name, "way", 3)) == 0)
		if ((strncmp
		     ((dat->d_name + (strlen (dat->d_name) - 4)), ".txt",
		      4)) == 0)
		  {
		    g_strlcpy ((names + dircount)->n, dat->d_name, 200);
		    dircount++;
		    if (dircount >= 100)
		      {
			error_popup (_
				     ("Don't use more than\n100 waypoint(way*.txt) files!"));
			g_free (names);
		      }
		  }
	    }
	}
      while (dat != NULL);
    }

  free (d);
  table2 = gtk_table_new (1 + (dircount - 1) / 2, 2, TRUE);
  setupentry[2] = ftable = gtk_frame_new (_("Waypoint files to use"));
  gtk_container_set_border_width (GTK_CONTAINER (ftable), 0);
  setupentrylabel[2] = gtk_label_new (_("Waypoints"));
  vbox = gtk_vbox_new (FALSE, 0);

  gtk_container_add (GTK_CONTAINER (ftable), vbox);
  gtk_box_pack_start (GTK_BOX (vbox), table2, FALSE, FALSE, 0);

  for (i = 0; i < dircount; i++)
    {
      if (i == 0)
	setupfn[i] = gtk_radio_button_new_with_label (NULL, (names + i)->n);
      else
	setupfn[i] = gtk_radio_button_new_with_label (gtk_radio_button_group
						      (GTK_RADIO_BUTTON
						       (setupfn[0])),
						      (names + i)->n);
      gtk_signal_connect (GTK_OBJECT (setupfn[i]), "clicked",
			  GTK_SIGNAL_FUNC (wpfileselect_cb), (gpointer) i);
      gtk_table_attach_defaults (GTK_TABLE (table2), setupfn[i], i % 2,
				 i % 2 + 1, i / 2, i / 2 + 1);
      if (!(strcmp (activewpfile, (names + i)->n)))
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (setupfn[i]), TRUE);

    }
  setupentrylabel[0] = gtk_label_new (_("Settings"));
  setupentry[0] = mainbox = gtk_vbox_new (FALSE, 0);
  setupentry[1] = mainbox2 = gtk_vbox_new (FALSE, 0);
  setupentrylabel[1] =
    gtk_label_new (g_strdup_printf ("%s 2", _("Settings")));

  gtk_container_set_border_width (GTK_CONTAINER (mainbox), 0);
  gtk_container_set_border_width (GTK_CONTAINER (mainbox2), 0);


  mapdirbt = gtk_entry_new_with_max_length (490);

  gtk_widget_set_size_request (mapdirbt, 20, 26);
  gtk_entry_set_text (GTK_ENTRY (mapdirbt), mapdir);
  label2 = gtk_label_new (_("Maps directory"));

  gtk_signal_connect (GTK_OBJECT (mapdirbt),
		      "changed", GTK_SIGNAL_FUNC (mapdir_cb), (gpointer) 1);


  night1 = gtk_radio_button_new_with_label (NULL, _("Automatic"));
  gtk_signal_connect (GTK_OBJECT (night1),
		      "clicked", GTK_SIGNAL_FUNC (night_cb), (gpointer) 2);

  night2 =
    gtk_radio_button_new_with_label (gtk_radio_button_group
				     (GTK_RADIO_BUTTON (night1)), _("On"));
  gtk_signal_connect (GTK_OBJECT (night2), "clicked",
		      GTK_SIGNAL_FUNC (night_cb), (gpointer) 1);
  night3 =
    gtk_radio_button_new_with_label (gtk_radio_button_group
				     (GTK_RADIO_BUTTON (night1)), _("Off"));
  gtk_signal_connect (GTK_OBJECT (night3), "clicked",
		      GTK_SIGNAL_FUNC (night_cb), (gpointer) 0);
  if (nightmode == 0)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (night3), TRUE);
  if (nightmode == 1)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (night2), TRUE);
  if (nightmode == 2)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (night1), TRUE);

/* GPS settings area */
  f4 = gtk_frame_new (_("GPS settings"));

  v4 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (f4), v4);

  gpstable = gtk_table_new (4, 2, TRUE);

//KCFX
  gtk_box_pack_end (GTK_BOX (mainbox2), f4, FALSE, TRUE, 0);
//  gtk_table_attach_defaults (GTK_TABLE (table), f4, 1, 2, 1, 2);
  gtk_box_pack_start (GTK_BOX (v4), gpstable, FALSE, FALSE, 0);
/*   gtk_container_add (GTK_CONTAINER (f4), gpstable); */


  noserialbt = gtk_check_button_new_with_label (_("Use serial conn."));
  if (!disableserial)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (noserialbt), TRUE);

  gtk_signal_connect (GTK_OBJECT (noserialbt),
		      "clicked", GTK_SIGNAL_FUNC (noserial_cb), (gpointer) 1);

  gtk_table_attach_defaults (GTK_TABLE (gpstable), noserialbt, 1, 2, 1, 2);


  serialbt = gtk_entry_new_with_max_length (20);
  gtk_widget_set_size_request (serialbt, 20, 26);

  gtk_entry_set_text (GTK_ENTRY (serialbt), serialdev);
  gtk_entry_set_max_length (GTK_ENTRY (serialbt), 40);
  label1 = gtk_label_new (_("Interface"));
  label1a = gtk_label_new (_("Baudrate"));

  gtk_signal_connect (GTK_OBJECT (serialbt),
		      "changed", GTK_SIGNAL_FUNC (serialdev_cb),
		      (gpointer) 1);

  gtk_table_attach_defaults (GTK_TABLE (gpstable), label1, 0, 1, 2, 3);
  gtk_table_attach_defaults (GTK_TABLE (gpstable), label1a, 1, 2, 2, 3);
  gtk_table_attach_defaults (GTK_TABLE (gpstable), serialbt, 0, 1, 3, 4);




  menu = gtk_menu_new ();
  for (i = 0; i < 5; i++)
    {
      g_snprintf (buf2, sizeof (buf2), "%d", br);
      if (i == 4)
	br += br / 2;
      else
	br += br;
      menu_item = gtk_menu_item_new_with_label (buf2);
      gtk_widget_show (menu_item);
      gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_item);
    }

  option_menu = gtk_option_menu_new ();
  gtk_option_menu_set_menu (GTK_OPTION_MENU (option_menu), menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (option_menu), serialspeed);
  gtk_signal_connect (GTK_OBJECT (option_menu), "changed",
		      GTK_SIGNAL_FUNC (baud_cb), (gpointer) 0);

  gtk_table_attach_defaults (GTK_TABLE (gpstable), option_menu, 1, 2, 3, 4);

/*  units area */
  f2 = gtk_frame_new (_("Units"));
  v2 = gtk_table_new (4, 2, FALSE);

  gtk_box_pack_start (GTK_BOX (mainbox), f2, FALSE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (f2), v2);

  miles = gtk_radio_button_new_with_label (NULL, _("Miles"));
  gtk_signal_connect (GTK_OBJECT (miles),
		      "clicked", GTK_SIGNAL_FUNC (miles_cb), (gpointer) 1);
  metric =
    gtk_radio_button_new_with_label (gtk_radio_button_group
				     (GTK_RADIO_BUTTON (miles)), _("Metric"));
  gtk_signal_connect (GTK_OBJECT (metric), "clicked",
		      GTK_SIGNAL_FUNC (miles_cb), (gpointer) 2);
  nautic =
    gtk_radio_button_new_with_label (gtk_radio_button_group
				     (GTK_RADIO_BUTTON (miles)), _("Nautic"));
  gtk_signal_connect (GTK_OBJECT (nautic), "clicked",
		      GTK_SIGNAL_FUNC (miles_cb), (gpointer) 3);
  if (milesflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (miles), TRUE);
  if (metricflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (metric), TRUE);
  if (nauticflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (nautic), TRUE);

  minsecbt = gtk_check_button_new_with_label (_("Decimal position"));
  if (!minsecmode)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (minsecbt), TRUE);

  gtk_signal_connect (GTK_OBJECT (minsecbt),
		      "clicked", GTK_SIGNAL_FUNC (minsec_cb), (gpointer) 0);

  gtk_table_attach_defaults (GTK_TABLE (v2), miles, 0, 1, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE (v2), metric, 0, 1, 1, 2);
  gtk_table_attach_defaults (GTK_TABLE (v2), nautic, 0, 1, 2, 3);
  gtk_table_attach_defaults (GTK_TABLE (v2), minsecbt, 1, 2, 0, 1);

/*  gtk_box_pack_start (GTK_BOX (v2), miles, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (v2), metric, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (v2), nautic, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (v2), minsecbt, TRUE, FALSE, 0);
*/
/*  default download server */
  h2 = gtk_hbox_new (FALSE, 0);
//KCFX

/* Night light mode */
  f5 = gtk_frame_new (_("Night light mode"));
  nighttable = gtk_table_new (1, 3, TRUE);
  gtk_container_add (GTK_CONTAINER (f5), nighttable);
/*   gtk_box_pack_start (GTK_BOX (h1), f5, TRUE, FALSE, 0);  */
  gtk_box_pack_start (GTK_BOX (h2), label2, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (h2), mapdirbt, TRUE, TRUE, 0);

  gtk_table_attach_defaults (GTK_TABLE (nighttable), night1, 0, 1, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE (nighttable), night2, 1, 2, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE (nighttable), night3, 2, 3, 0, 1);

//KCFX
  gtk_box_pack_end (GTK_BOX (mainbox2), f5, FALSE, TRUE, 0);
//  gtk_table_attach_defaults (GTK_TABLE (table), f5, 0, 2, 2, 3);

/* Sound settings */

  framesound = gtk_frame_new (_("Speech output settings"));
  soundtable = gtk_table_new (2, 2, TRUE);
  gtk_container_add (GTK_CONTAINER (framesound), soundtable);

/*
set following sounds
sound_direction ... say direction to target
sound_distance  ... say distance to target
sound_speed     ... say your current speed
sound_gps       ... say GPS status

*/
  sounddirbt = gtk_check_button_new_with_label (_("Direction"));
  if (sound_direction)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sounddirbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (sounddirbt),
		      "clicked", GTK_SIGNAL_FUNC (soundsettings_cb),
		      (gpointer) 1);

  sounddistbt = gtk_check_button_new_with_label (_("Distance"));
  if (sound_distance)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sounddistbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (sounddistbt),
		      "clicked", GTK_SIGNAL_FUNC (soundsettings_cb),
		      (gpointer) 2);

  soundspeedbt = gtk_check_button_new_with_label (_("Speed"));
  if (sound_speed)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (soundspeedbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (soundspeedbt),
		      "clicked", GTK_SIGNAL_FUNC (soundsettings_cb),
		      (gpointer) 3);

  soundgpsbt = gtk_check_button_new_with_label (_("GPS Status"));
  if (sound_gps)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (soundgpsbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (soundgpsbt),
		      "clicked", GTK_SIGNAL_FUNC (soundsettings_cb),
		      (gpointer) 4);
  gtk_table_attach_defaults (GTK_TABLE (soundtable), sounddirbt, 0, 1, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE (soundtable), sounddistbt, 0, 1, 1, 2);
  gtk_table_attach_defaults (GTK_TABLE (soundtable), soundspeedbt, 1, 2, 0,
			     1);
  gtk_table_attach_defaults (GTK_TABLE (soundtable), soundgpsbt, 1, 2, 1, 2);

  gtk_table_set_row_spacings (GTK_TABLE (table2), 0);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 0);

  gtk_widget_show_all (mainbox);
/*    g_free (names); */

}

void
testifnight (void)
{
  daylights ();
  isnight = FALSE;
  if (hour > sunset)
    isnight = TRUE;
  if (hour < sunrise)
    isnight = TRUE;

  if (debug)
    {
      if (isnight)
	g_print ("\nIt is night");
      else
	g_print ("\nIt is day");
    }
}


void
daylights (void)
{
  gint Rank, D, TZ;
  gdouble MA, C, RR, ET, L, Dec, Ho, lat, lon;
  time_t now = time (NULL);
  struct tm *st = localtime (&now);

  lat = M_PI * current_lat / 180.0;
  lon = M_PI * current_long / 180.0;
  Rank = st->tm_yday + 1;
  D = st->tm_mday;
  MA = 357 + 0.9856 * Rank;
  C = 1.914 * sin (M_PI * MA / 180.0) + 0.02 * sin (2 * M_PI * MA / 180.0);
  L = 280.0 + C + 0.9856 * Rank;
  RR =
    -2.466 * sin (2.0 * M_PI * L / 180.0) +
    0.053 * sin (4 * M_PI * L / 180.0);
  ET = (C + RR) * 4;
  Dec = asin (0.3978 * sin (M_PI * L / 180.0));
  Ho = acos (((-0.01454 - sin (Dec) * sin (lat)) / (cos (Dec) * cos (lat))));
  Ho = 180.0 * Ho / M_PI;
  Ho = Ho / 15;

  TZ = zone;

  sunrise = 12.0 - Ho + ET / 60.0 - current_long / 15 + TZ;
  suntransit = 12 + ET / 60.0 - current_long / 15 + TZ;
  sunset = 12.0 + Ho + ET / 60.0 - current_long / 15 + TZ;

  if (sunrise < 0)
    sunrise += 24;
  if (suntransit < 0)
    suntransit += 24;
  if (sunset < 0)
    sunset += 24;

  if (sunrise > 24)
    sunrise -= 24;
  if (suntransit > 24)
    suntransit -= 24;
  if (sunset > 24)
    sunset -= 24;


  Ho = acos (((-0.309 - sin (Dec) * sin (lat)) / (cos (Dec) * cos (lat))));
  Ho = 180.0 * Ho / M_PI;
  Ho = Ho / 15;
  dawnastro = 12.0 - Ho + ET / 60.0 - current_long / 15 + TZ;
  duskastro = 12.0 + Ho + ET / 60.0 - current_long / 15 + TZ;

  Ho = acos (((-0.208 - sin (Dec) * sin (lat)) / (cos (Dec) * cos (lat))));
  Ho = 180.0 * Ho / M_PI;
  Ho = Ho / 15;
  dawnnaut = 12.0 - Ho + ET / 60.0 - current_long / 15 + TZ;
  dusknaut = 12.0 + Ho + ET / 60.0 - current_long / 15 + TZ;

  Ho = acos (((-0.105 - sin (Dec) * sin (lat)) / (cos (Dec) * cos (lat))));
  Ho = 180.0 * Ho / M_PI;
  Ho = Ho / 15;
  dawnciv = 12.0 - Ho + ET / 60.0 - current_long / 15 + TZ;
  duskciv = 12.0 + Ho + ET / 60.0 - current_long / 15 + TZ;

  if (dawnastro < 0)
    dawnastro += 24;
  if (dawnnaut < 0)
    dawnnaut += 24;
  if (dawnciv < 0)
    dawnciv += 24;
  if (duskastro < 0)
    duskastro += 24;
  if (dusknaut < 0)
    dusknaut += 24;
  if (duskciv < 0)
    duskciv += 24;

  if (dawnastro > 24)
    dawnastro -= 24;
  if (dawnnaut > 24)
    dawnnaut -= 24;
  if (dawnciv > 24)
    dawnciv -= 24;
  if (duskastro > 24)
    duskastro -= 24;
  if (dusknaut > 24)
    dusknaut -= 24;
  if (duskciv > 24)
    duskciv -= 24;


  hour = st->tm_hour;
  hour = hour + st->tm_min / 60.0;
  if (debug)
    {
      g_print ("\nhour: %d:%02d, sunrise: %d:%02d ",
	       (int) hour, (int) ((hour - (int) hour) * 60), (int) sunrise,
	       (int) ((sunrise - (int) sunrise) * 60));
      g_print ("\nhour: %d:%02d, transit: %d:%02d ",
	       (int) hour, (int) ((hour - (int) hour) * 60), (int) suntransit,
	       (int) ((suntransit - (int) suntransit) * 60));
      g_print ("\nhour: %d:%02d, sunset: %d:%02d ",
	       (int) hour, (int) ((hour - (int) hour) * 60), (int) sunset,
	       (int) ((sunset - (int) sunset) * 60));
    }

/* Formulas for dawn and dusk are almost the same than sunrise and sunset. In the */
/* formula for Cos Ho -0.01454 must be replaced by: */
/* astronomical: -0.309 */
/* nautical: -0.208 */
/* civil: -0.105 */
}

gint
infosettz (GtkWidget * widget, guint datum)
{
  gchar *sc;

  sc = (char *) gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (ge12)->entry));
  sscanf (sc, "GMT%d", &zone);
  needtosave = TRUE;
  if (debug)
    g_print ("\nTimezone: %d", zone);
  return TRUE;
}

gint
storetz_cb (GtkWidget * widget, guint datum)
{
  storetz = !storetz;
  needtosave = TRUE;
  fprintf (stderr, "storetz: %d\n", storetz);
  return TRUE;
}

void
infos (void)
{
  GtkWidget *mainbox, *frame, *l1, *l2, *l5, *e1, *e2;
  GtkWidget *e3, *e4, *e5, *l6, *l8, *l9, *l10, *l11, *l12, *l13;
  GtkWidget *e6, *e7, *e8, *e9, *e10, *e11;
  GtkWidget *table;
  gchar text[80];
  GList *list = NULL;
  gint i;

  for (i = 0; i < 25; i++)
    list = g_list_append (list, slist[i]);

  setupentry[3] = frame = gtk_frame_new (_("Geo information"));
  gtk_container_set_border_width (GTK_CONTAINER (frame), 0);
  setupentrylabel[3] = gtk_label_new (_("Geo info"));

  testifnight ();

  mainbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame), mainbox);

  table = gtk_table_new (10, 3, FALSE);
  gtk_box_pack_start (GTK_BOX (mainbox), table, FALSE, FALSE, 0);


  l11 = gtk_label_new (_("Sunrise"));
  gtk_table_attach_defaults (GTK_TABLE (table), l11, 1, 2, 0, 1);
  l9 = gtk_label_new (_("Sunset"));
  gtk_table_attach_defaults (GTK_TABLE (table), l9, 2, 3, 0, 1);

  l1 = gtk_label_new (_("Standard"));
  gtk_table_attach_defaults (GTK_TABLE (table), l1, 0, 1, 1, 2);
  l2 = gtk_label_new (_("Transit"));
  gtk_table_attach_defaults (GTK_TABLE (table), l2, 0, 1, 6, 7);
  l5 = gtk_label_new (_("GPS-Time"));
  gtk_table_attach_defaults (GTK_TABLE (table), l5, 0, 1, 7, 8);
  l6 = gtk_label_new (_("Astro."));
  gtk_table_attach_defaults (GTK_TABLE (table), l6, 0, 1, 2, 3);
  l8 = gtk_label_new (_("Naut."));
  gtk_table_attach_defaults (GTK_TABLE (table), l8, 0, 1, 3, 4);
  l10 = gtk_label_new (_("Civil"));
  gtk_table_attach_defaults (GTK_TABLE (table), l10, 0, 1, 4, 5);
  l12 = gtk_label_new (_("Timezone"));
  gtk_table_attach_defaults (GTK_TABLE (table), l12, 0, 1, 9, 10);
  l13 = gtk_check_button_new_with_label (_("Store TZ"));
  gtk_table_attach_defaults (GTK_TABLE (table), l13, 2, 3, 9, 10);
  if (storetz)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (l13), TRUE);
  gtk_signal_connect (GTK_OBJECT (l13),
		      "clicked", GTK_SIGNAL_FUNC (storetz_cb), (gpointer) 0);

  e1 = gtk_entry_new ();
  if (sunrise > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d", (int) sunrise,
		(int) ((sunrise - (int) sunrise) * 60));
  gtk_entry_set_text (GTK_ENTRY (e1), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e1, 1, 2, 1, 2);

  e2 = gtk_entry_new ();
  if (sunset > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d", (int) sunset,
		(int) ((sunset - (int) sunset) * 60));
  gtk_entry_set_text (GTK_ENTRY (e2), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e2, 2, 3, 1, 2);

  e3 = gtk_entry_new ();
  if (suntransit > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) suntransit,
		(int) ((suntransit - (int) suntransit) * 60),
		(int) ((suntransit * 60 - (int) (suntransit * 60)) * 60));
  gtk_entry_set_text (GTK_ENTRY (e3), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e3, 1, 2, 6, 7);

  e4 = gtk_entry_new ();
  if (isnight)
    g_snprintf (text, sizeof (text), "%s", _("Night"));
  else
    g_snprintf (text, sizeof (text), "%s", _("Day"));
  gtk_entry_set_text (GTK_ENTRY (e4), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e4, 2, 3, 7, 8);

  utclabel = e5 = gtk_entry_new ();


  g_snprintf (text, sizeof (text), "%s", loctime);
  gtk_entry_set_text (GTK_ENTRY (e5), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e5, 1, 2, 7, 8);

  e6 = gtk_entry_new ();
  if (dawnastro > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) dawnastro,
		(int) ((dawnastro - (int) dawnastro) * 60),
		(int) ((dawnastro * 60 - (int) (dawnastro * 60)) * 60));

  gtk_entry_set_text (GTK_ENTRY (e6), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e6, 1, 2, 2, 3);
  e7 = gtk_entry_new ();
  if (dawnnaut > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) dawnnaut,
		(int) ((dawnnaut - (int) dawnnaut) * 60),
		(int) ((dawnnaut * 60 - (int) (dawnnaut * 60)) * 60));
  gtk_entry_set_text (GTK_ENTRY (e7), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e7, 1, 2, 3, 4);
  e8 = gtk_entry_new ();
  if (dawnciv > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) dawnciv,
		(int) ((dawnciv - (int) dawnciv) * 60),
		(int) ((dawnciv * 60 - (int) (dawnciv * 60)) * 60));

  gtk_entry_set_text (GTK_ENTRY (e8), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e8, 1, 2, 4, 5);

  e9 = gtk_entry_new ();
  if (duskastro > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) duskastro,
		(int) ((duskastro - (int) duskastro) * 60),
		(int) ((duskastro * 60 - (int) (duskastro * 60)) * 60));
  gtk_entry_set_text (GTK_ENTRY (e9), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e9, 2, 3, 2, 3);
  e10 = gtk_entry_new ();
  if (dusknaut > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) dusknaut,
		(int) ((dusknaut - (int) dusknaut) * 60),
		(int) ((dusknaut * 60 - (int) (dusknaut * 60)) * 60));

  gtk_entry_set_text (GTK_ENTRY (e10), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e10, 2, 3, 3, 4);
  e11 = gtk_entry_new ();
  if (duskciv > 24.0)
    g_strlcpy (text, _("n/a"), sizeof (text));
  else
    g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) duskciv,
		(int) ((duskciv - (int) duskciv) * 60),
		(int) ((duskciv * 60 - (int) (duskciv * 60)) * 60));

  gtk_entry_set_text (GTK_ENTRY (e11), text);
  gtk_table_attach_defaults (GTK_TABLE (table), e11, 2, 3, 4, 5);
  ge12 = gtk_combo_new ();
  gtk_combo_set_popdown_strings (GTK_COMBO (ge12), (GList *) list);
  gtk_entry_set_text (GTK_ENTRY (GTK_COMBO (ge12)->entry), slist[zone + 12]);
  gtk_signal_connect (GTK_OBJECT (GTK_COMBO (ge12)->entry), "changed",
		      GTK_SIGNAL_FUNC (infosettz), (gpointer) 0);

  gtk_table_attach_defaults (GTK_TABLE (table), ge12, 1, 2, 9, 10);

  gtk_entry_set_editable (GTK_ENTRY (e1), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e2), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e3), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e4), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e5), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e6), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e7), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e8), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e9), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e10), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (e11), FALSE);
  gtk_widget_set_usize (e1, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e2, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e3, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e4, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e5, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e6, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e7, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e8, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e9, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e10, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (e11, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (ge12, USIZE_X, USIZE_Y);
  gtk_table_set_row_spacings (GTK_TABLE (table), 0);
  gtk_table_set_col_spacings (GTK_TABLE (table), 0);
  utctimer = gtk_timeout_add (300, (GtkFunction) setutc, 0);

  gtk_widget_show_all (frame);
}



gint
settripvalues (GtkWidget * widget, guint datum)
{
  gchar text[80], s1[80];
  gdouble f;

  if ((GTK_IS_WIDGET (entrytripodometer)) == FALSE)
    return FALSE;

  g_snprintf (text, sizeof (text), "%.3f", tripodometer * milesconv);
  gtk_entry_set_text (GTK_ENTRY (entrytripodometer), text);
  f = (time (NULL) - triptime) / 3600.0;
  g_snprintf (text, sizeof (text), "%02d:%02d:%02d", (int) f,
	      (int) ((f - (int) f) * 60),
	      (int) ((f * 60 - (int) (f * 60)) * 60));
  gtk_entry_set_text (GTK_ENTRY (entrytriptime), text);
  if (tripavspeedcount > 0)
    g_snprintf (text, sizeof (text), "%.1f",
		tripavspeed * milesconv / tripavspeedcount);
  else
    g_snprintf (text, sizeof (text), "---");
  gtk_entry_set_text (GTK_ENTRY (entryavspeed), text);

  g_snprintf (text, sizeof (text), "%.1f", tripmaxspeed * milesconv);
  gtk_entry_set_text (GTK_ENTRY (entrymaxspeed), text);

  if (milesflag)
    g_snprintf (s1, sizeof (s1), "%s [%s]", _("Unit:"), _("miles"));
  else if (nauticflag)
    g_snprintf (s1, sizeof (s1), "%s [%s]", _("Unit:"),
		_("nautic miles/knots"));
  else
    g_snprintf (s1, sizeof (s1), "%s [%s]", _("Unit:"), _("kilometers"));

  gtk_label_set_text (GTK_LABEL (tripunitlabel), s1);
  return TRUE;
}


void
trip (void)
{
  GtkWidget *mainbox, *frame, *l1, *l2, *l5;
  GtkWidget *l6;
  GtkWidget *table, *knopf;

  setupentry[4] = frame = gtk_frame_new (_("Trip information"));
  gtk_container_set_border_width (GTK_CONTAINER (frame), 0);
  setupentrylabel[4] = gtk_label_new (_("Trip info"));


  mainbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame), mainbox);


  table = gtk_table_new (6, 2, FALSE);
  gtk_box_pack_start (GTK_BOX (mainbox), table, FALSE, FALSE, 0);


  tripunitlabel = gtk_label_new ("---");
  gtk_table_attach_defaults (GTK_TABLE (table), tripunitlabel, 0, 2, 0, 1);

  l1 = gtk_label_new (_("Odometer"));
  gtk_table_attach_defaults (GTK_TABLE (table), l1, 0, 1, 1, 2);
  l2 = gtk_label_new (_("Total time"));
  gtk_table_attach_defaults (GTK_TABLE (table), l2, 0, 1, 2, 3);
  l5 = gtk_label_new (_("Av. speed"));
  gtk_table_attach_defaults (GTK_TABLE (table), l5, 0, 1, 3, 4);
  l6 = gtk_label_new (_("Max. speed"));
  gtk_table_attach_defaults (GTK_TABLE (table), l6, 0, 1, 4, 5);

  entrytripodometer = gtk_entry_new ();
  gtk_entry_set_text (GTK_ENTRY (entrytripodometer), "---");
  gtk_table_attach_defaults (GTK_TABLE (table), entrytripodometer, 1, 2, 1,
			     2);


  entrytriptime = gtk_entry_new ();
  gtk_entry_set_text (GTK_ENTRY (entrytriptime), "---");
  gtk_table_attach_defaults (GTK_TABLE (table), entrytriptime, 1, 2, 2, 3);


  entryavspeed = gtk_entry_new ();


  gtk_entry_set_text (GTK_ENTRY (entryavspeed), "---");
  gtk_table_attach_defaults (GTK_TABLE (table), entryavspeed, 1, 2, 3, 4);

  entrymaxspeed = gtk_entry_new ();
  gtk_entry_set_text (GTK_ENTRY (entrymaxspeed), "---");
  gtk_table_attach_defaults (GTK_TABLE (table), entrymaxspeed, 1, 2, 4, 5);

  knopf = gtk_button_new_with_label (_("Reset"));
  gtk_signal_connect_object (GTK_OBJECT (knopf), "clicked",
			     GTK_SIGNAL_FUNC (tripreset), NULL);

  gtk_table_attach_defaults (GTK_TABLE (table), knopf, 1, 2, 5, 6);

  gtk_entry_set_editable (GTK_ENTRY (entrytripodometer), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (entryavspeed), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (entrytriptime), FALSE);
  gtk_entry_set_editable (GTK_ENTRY (entrymaxspeed), FALSE);
  gtk_widget_set_usize (entrytripodometer, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (entryavspeed, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (entrytriptime, USIZE_X, USIZE_Y);
  gtk_widget_set_usize (entrymaxspeed, USIZE_X, USIZE_Y);
  gtk_table_set_row_spacings (GTK_TABLE (table), 0);
  gtk_table_set_col_spacings (GTK_TABLE (table), 0);
  gtk_widget_show_all (frame);
  triptimer = gtk_timeout_add (1000, (GtkFunction) settripvalues, 0);
}

gint
noserial_cb (GtkWidget * widget, guint datum)
{
  disableserial = !disableserial;
  needtosave = TRUE;
  return TRUE;
}

gint
setutc (GtkWidget * widget, guint datum)
{
  gchar text[20];
  g_snprintf (text, sizeof (text), "%s", loctime);
/*   g_print("\nwidget da: %d", GTK_IS_WIDGET(utclabel));  */
  if (GTK_IS_WIDGET (utclabel))
    gtk_entry_set_text (GTK_ENTRY (utclabel), text);

  return TRUE;
}

gint
removesetutc (GtkWidget * widget, guint datum)
{
/*   g_print ("\n\nremove timer!\n\a\n"); */
  lastnotebook =
    gtk_notebook_get_current_page (GTK_NOTEBOOK (settingsnotebook));
  gtk_timeout_remove (utctimer);
  if (triptimer != 0)
    {
      gtk_timeout_remove (triptimer);
      triptimer = 0;
    }
  gtk_widget_set_sensitive (setupbt, TRUE);
  return TRUE;
}
